<?
// $Id

// Credits: most of the parsing code is taken from MediaWiki 1.10.0
// (licenced under GPL2)

function _easylists_filter_process(&$body, $format = -1)
{
  $listprocessor = new listprocessor;
  $body = $listprocessor->process($body);
  return $body;
}

class listprocessor
{
  function process($body)
  {
    $textLines = explode( "\n", $body );
    $lastPrefix = $output = '';
    $inBlockElem = false;
    $prefixLength = 0;
    $paragraphStack = false;
    foreach ( $textLines as $oLine )
    {
      // lists
      $lastPrefixLength = strlen( $lastPrefix );
      $prefixLength = strspn( $oLine, '-' );
      $pref = substr( $oLine, 0, $prefixLength );
      $t = substr( $oLine, $prefixLength );
 
      if( $prefixLength && 0 == strcmp( $lastPrefix, $pref ) )
      {
        # Same as the last item, so no need to deal with nesting or opening stuff
        $output .= $this->nextItem( substr( $pref, -1 ) );
        $paragraphStack = false;
      }
      elseif( $prefixLength || $lastPrefixLength )
      {
        # Either open or close a level...
        $commonPrefixLength = $this->getCommon( $pref, $lastPrefix );
        $paragraphStack = false;
        while( $commonPrefixLength < $lastPrefixLength )
        {
          $output .= $this->closeList( $lastPrefix{$lastPrefixLength-1} );
          --$lastPrefixLength;
        }
        if ( $prefixLength <= $commonPrefixLength && $commonPrefixLength > 0 ) {
          $output .= $this->nextItem( $pref{$commonPrefixLength-1} );
        }
        while ( $prefixLength > $commonPrefixLength ) {
          $char = substr( $pref, $commonPrefixLength, 1 );
          $output .= $this->openList( $char, $prefixLength > 1 );
          ++$commonPrefixLength;
        }
        $lastPrefix = $pref;
      }
    
      // somewhere above we forget to get out of pre block (bug 785)
      if ($paragraphStack === false) {

        // headers
        $headerPrefixLength = strspn( $t, '=' );
        if ($headerPrefixLength && substr($t, strlen($t)-$headerPrefixLength)==substr($t, 0, $headerPrefixLength))
        {
          $t = substr( $t, $headerPrefixLength, strlen($t)-($headerPrefixLength*2) );
          $t = '<h'.($headerPrefixLength+2).'>'.$t.'</h'.($headerPrefixLength+2).'>';
        }

        $output .= $t."\n";
      }
    }  
    while ( $prefixLength ) {
      $output .= $this->closeList( $pref{$prefixLength-1} );
      --$prefixLength;
    }
    if ( '' != $this->mLastSection ) {
      $output .= '</' . $this->mLastSection . '>';
      $this->mLastSection = '';
    }

    return $output;
  }

  function getCommon( $st1, $st2 )
  {
    $fl = strlen( $st1 );
    $shorter = strlen( $st2 );
    if ( $fl < $shorter ) { $shorter = $fl; }

    for ( $i = 0; $i < $shorter; ++$i ) {
      if ( $st1{$i} != $st2{$i} ) { break; }
     }
    return $i;
  }

  function openList( $char, $sublist=false )
  {
    $result = $this->closeParagraph();
    if ($sublist)
      $class = "easylist sublist";
    else
      $class = "easylist";

    if ( '-' == $char ) { $result .= '<ul class="'.$class.'"><li>'; }
    else { $result = '<!-- ERR 1 -->'; }
    return $result;
  }

  function closeParagraph() {
    $result = '';
    if ( '' != $this->mLastSection ) {
      $result = '</' . $this->mLastSection  . ">\n";
    }
    $this->mInPre = false;
    $this->mLastSection = '';
    return $result;
  }

  function nextItem( $char ) {
    if ( '-' == $char ) { return '</li><li>'; }
    return '<!-- ERR 2 -->';
  }

  function closeList( $char ) {
    if ( '-' == $char ) { $text = '</li></ul>'; }
    else {  return '<!-- ERR 3 -->'; }
    return $text."\n";
  }
}
